|
123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358 |
- #!/bin/sh
-
- command -V gpg >/dev/null 2>&1 && GPG="gpg" || GPG="gpg2"
- [ -z ${PASSWORD_STORE_DIR+x} ] && PASSWORD_STORE_DIR="$HOME/.password-store"
- [ -r "$PASSWORD_STORE_DIR/.gpg-id" ] &&
- "$GPG" --list-secret-keys $(cat "$PASSWORD_STORE_DIR/.gpg-id") >/dev/null 2>&1 || {
- printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`%s --full-gen-key\` first.\\n" "$GPG"
- exit 1
- }
-
- prefix="/usr/local"
- pass_prefix="mw-"
- muttdir="${XDG_CONFIG_HOME:-$HOME/.config}/mutt" # Main mutt config location
- accdir="$muttdir/accounts" # Directory for account settings
- maildir="${XDG_DATA_HOME:-$HOME/.local/share}/mail" # Location of mail storage
- emailre=".+@.+\..+" # Regex to confirm valid email address
- muttshare="$prefix/share/mutt-wizard"
- mbsyncrc="${MBSYNCRC:-$HOME/.mbsyncrc}"
- mwconfig="$muttshare/mutt-wizard.muttrc"
- cachedir="${XDG_CACHE_HOME:-$HOME/.cache}/mutt-wizard"
- muttrc="$muttdir/muttrc"
- msmtprc="${XDG_CONFIG_HOME:-$HOME/.config}/msmtp/config"
- msmtplog="${XDG_CONFIG_HOME:-$HOME/.config}/msmtp/msmtp.log"
- MARKER="# mw-autogenerated"
- alias mbsync='mbsync -c "$mbsyncrc"'
-
- for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" "/etc/ssl/cert.pem" "/usr/local/share/ca-certificates/"
- do
- [ -f "$x" ] && sslcert="$x" && break
- done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
-
- getaccounts() { accounts="$(find -L "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\.muttrc$//" | sort -n)" ;}
-
- list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
-
- getprofiles() { \
- unset msmtp_header msmtp_profile mutt_profile mbsync_profile
- msmtp_header="defaults
- auth on
- tls on
- tls_trust_file $sslcert
- logfile $msmtplog
- "
- msmtp_profile="account $fulladdr
- host $smtp
- port ${sport:-587}
- from $fulladdr
- user $login
- passwordeval \"pass $pass_prefix$fulladdr\"
- $tlsline
- "
- mbsync_profile="IMAPStore $fulladdr-remote
- Host $imap
- Port ${iport:-993}
- User $login
- PassCmd \"pass $pass_prefix$fulladdr\"
- AuthMechs LOGIN
- SSLType ${ssltype:-IMAPS}
- CertificateFile $sslcert
-
- MaildirStore $fulladdr-local
- Subfolders Verbatim
- Path ${XDG_DATA_HOME:-$HOME/.local/share}/mail/$fulladdr/
- Inbox ${XDG_DATA_HOME:-$HOME/.local/share}/mail/$fulladdr/INBOX
- Flatten .
-
- Channel $fulladdr
- Expunge Both
- Master :$fulladdr-remote:
- Slave :$fulladdr-local:
- Patterns * !\"[Gmail]/All Mail\"
- Create Both
- SyncState *
- MaxMessages ${maxmes:-0}
- ExpireUnread no
- # End profile
- "
-
- if [ -z "${online+x}" ]; then
- mutt_profile="# vim: filetype=neomuttrc
- # muttrc file for account $fulladdr
- set realname = \"$realname\"
- set from = \"$fulladdr\"
- set sendmail = \"msmtp -a $fulladdr\"
- alias me $realname <$fulladdr>
- set folder = \"$maildir/$fulladdr\"
- set header_cache = $cachedir/$fulladdr/headers
- set message_cachedir = $cachedir/$fulladdr/bodies
- set mbox_type = Maildir
-
- bind index,pager gg noop
- bind index,pager g noop
- bind index,pager M noop
- bind index,pager C noop
- bind index gg first-entry
- macro index o \"<shell-escape>mw -y $fulladdr<enter>\" \"run mbsync to sync $fulladdr\"
- unmailboxes *
- "
- else
- mutt_profile="# vim: filetype=neomuttrc
- # muttrc file for account $fulladdr
- set realname = \"$realname\"
- set from = \"$fulladdr\"
- set sendmail = \"msmtp -a $fulladdr\"
- alias me $realname <$fulladdr>
- set folder = \"imaps://$login@$imap:${iport:-993}\"
- set imap_user = \"$login\"
- set header_cache = $cachedir/$fulladdr/headers
- set message_cachedir = $cachedir/$fulladdr/bodies
- set imap_pass = \"\`pass $pass_prefix$fulladdr\`\"
-
- set mbox_type = Maildir
- set ssl_starttls = yes
- set ssl_force_tls = yes
-
- bind index,pager gg noop
- bind index,pager g noop
- bind index,pager M noop
- bind index,pager C noop
- bind index gg first-entry
- unmailboxes *
- "
- fi
- }
-
- parsedomains(){ serverinfo="$(grep "^${fulladdr#*@}" "$muttshare/domains.csv" 2>/dev/null)"
-
- [ -z "$serverinfo" ] && serverinfo="$(grep "$(echo "${fulladdr#*@}" | sed "s/\.[^\.]*$/\.\\\*/")" "$muttshare/domains.csv" 2>/dev/null)"
-
- IFS=, read -r service imapsugg iportsugg smtpsugg sportsugg <<EOF
- $serverinfo
- EOF
- imap="${imap:-$imapsugg}"
- smtp="${smtp:-$smtpsugg}"
- sport="${sport:-$sportsugg}"
- iport="${iport:-$iportsugg}"
- }
-
- delete() { if [ -z "${fulladdr+x}" ]; then
- echo "Select the account your would like to delete (by number):"
- list
- read -r input
- match="^$input:"
- else
- match=" $fulladdr$"
- getaccounts
- fi
-
- fulladdr="$(echo "$accounts" | grep "$match" | cut -f2 -d' ')"
-
- [ -z "$fulladdr" ] && echo "Invalid account name given." && return 1
-
- sed -ibu "/IMAPStore $fulladdr-remote$/,/# End profile/d" "$mbsyncrc" ; rm -rf "$mbsyncrc"bu
- rm -rf "${cachedir:?}/${fulladdr:?}" "$accdir/"[1-9]"-$fulladdr.muttrc"
- sed -ibu "/[0-9]-$fulladdr.muttrc/d" "$muttrc" ; rm -f "$muttrc"bu
- sed -ibu "/account $fulladdr/,/^\(\s*$\|account\)/d" "$msmtprc"; rm -f "$msmtprc"bu
- pass rm -f "$pass_prefix$fulladdr" >/dev/null 2>&1
- }
-
- askinfo() { \
- [ -z "$fulladdr" ] && echo "Give the full email address to add:" &&
- read -r fulladdr
- while ! echo "$fulladdr" | grep -qE "$emailre"; do
- echo "\`$fulladdr\` is not a valid email address. Please retype the address:"
- read -r fulladdr
- done
- { [ -z "$imap" ] || [ -z "$smtp" ] ;} && parsedomains
- [ -z "$imap" ] && echo "Give your email server's IMAP address (excluding the port number):" &&
- read -r imap
- [ -z "$smtp" ] && echo "Give your email server's SMTP address (excluding the port number):" &&
- read -r smtp
- [ "$sport" = 465 ] && tlsline="tls_starttls off"
- [ -z "$realname" ] && echo "Give the name you would like to be identified by on the email account:" &&
- read -r realname
- login="${login:-$fulladdr}"
- if [ -n "${password+x}" ]; then
- createpass
- else
- getpass
- fi
- }
-
- createpass() { echo "$password" > "$PASSWORD_STORE_DIR/$pass_prefix$fulladdr"
- "$GPG" -qer "$(cat "$PASSWORD_STORE_DIR/.gpg-id")" "$PASSWORD_STORE_DIR/$pass_prefix$fulladdr"
- rm -f "$PASSWORD_STORE_DIR/$pass_prefix$fulladdr" ;}
-
- writeinfo() { mkdir -p "$muttdir" "$accdir" "$cachedir/$fulladdr/bodies" "${XDG_CONFIG_HOME:-$HOME/.config}/msmtp" "$maildir/$fulladdr"
-
- # Get accounts and find the first missing account number (max. 9).
- getaccounts; for x in $(seq 1 9); do echo "$accounts" | grep -q "$x" || { export idnum="$x"; break ;}; done
-
- # Configure msmtprc for sending mail.
- [ ! -f "$msmtprc" ] && echo "$msmtp_header" > "$msmtprc"
- echo "$msmtp_profile" >> "$msmtprc"
- # On Ubuntu/Debian, a link is needed since they use an older version.
- command -V apt-get >/dev/null 2>&1 && ln -s "$msmtprc" "$HOME/.msmtprc" 2>/dev/null
-
- # Create the mbsync config file.
- mkdir -p "${mbsyncrc%/*}"
- echo "$mbsync_profile" >> "$mbsyncrc"
-
- # Create a muttrc for viewing mail.
- echo "$mutt_profile" > "$accdir/$idnum-$fulladdr.muttrc"
- [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc"
- ! grep -q "^source.*mutt-wizard.muttrc" "$muttrc" && echo "source $mwconfig $MARKER" >> "$muttrc"
- ! grep "^source.*.muttrc" "$muttrc" | grep -qv "$mwconfig" && echo "source $accdir/$idnum-$fulladdr.muttrc $MARKER" >> "$muttrc"
- echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$fulladdr.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" $MARKER" >> "$muttrc"
-
- notmuchauto # Create a notmuch config file if not present already.
- }
-
- getpass() { while : ; do pass rm -f "$pass_prefix$fulladdr" >/dev/null 2>&1
- pass insert "$pass_prefix$fulladdr" && break; done ;}
-
- formatShortcut() { toappend="$toappend
- macro index,pager g$1 \"<change-folder>=$3<enter>\" \"go to $2\" $MARKER
- macro index,pager M$1 \";<save-message>=$3<enter>\" \"move mail to $2\" $MARKER
- macro index,pager C$1 \";<copy-message>=$3<enter>\" \"copy mail to $2\" $MARKER" >> "$accdir/$idnum-$fulladdr.muttrc" ;}
-
- setBox() { toappend="$toappend
- set $1 = \"+$2\" $MARKER" ;}
-
- getboxes() { [ -n "${force+x}" ] && mailboxes="INBOX
- Drafts
- Junk
- Trash
- Sent
- Archive" && return 0
- if mailboxes="$(mbsync -l "$fulladdr" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
- [ -n "${online+x}" ] && sed -ibu "/IMAPStore $fulladdr-remote$/,/# End profile/d" "$mbsyncrc" ; rm -f "$mbsyncrc"bu
- return 0
- else
- echo "$mailboxes"
- printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
- return 1
- fi ;}
-
- finalize() { echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$fulladdr/{}/cur" "$maildir/$fulladdr/{}/tmp" "$maildir/$fulladdr/{}/new"
- sed -ibu "/$MARKER/d" "$accdir/$idnum-$fulladdr.muttrc" ; rm -f "$accdir/$idnum-$fulladdr.muttrcbu"
- toappend="mailboxes $(echo "$mailboxes" | sed "s/^/\"=/;s/$/\"/" | paste -sd ' ' )"
- for x in $mailboxes; do
- case $x in
- *[Ss][Ee][Nn][Tt]*) setBox record "$x"; formatShortcut s sent "$x" ;;
- *[Dd][Rr][Aa][Ff][Tt][Ss]*) setBox postponed "$x"; formatShortcut d drafts "$x" ;;
- *[Tt][Rr][Aa][Ss][Hh]*) formatShortcut t trash "$x"; setBox trash "$x" ;;
- *[Jj][Uu][Nn][Kk]*) formatShortcut j junk "$x" ;;
- *[Aa][Rr][Cc][Hh][Ii][Vv][Ee]*) formatShortcut a archive "$x" ;;
- *[Ss][Pp][Aa][Mm]*) formatShortcut S spam "$x" ;;
- *[Ii][Nn][Bb][Oo][Xx]*) formatShortcut i inbox "$x"; setBox spoolfile "$x" ;;
- esac
- done
- echo "$toappend" >> "$accdir/$idnum-$fulladdr.muttrc"
- [ -z "${online+x}" ] && printf "\033[33mYou should now be able to run \`\033[32mmw -y %s\033[33m\` to begin to download your mail.\033[0m\\n" "$fulladdr"
- command -V urlview >/dev/null 2>&1 && [ ! -f "$HOME/.urlview" ] && echo "COMMAND \$BROWSER" > "$HOME/.urlview"
- return 0 ;}
-
- syncwrapper() { mbsync "${1:--a}" &
- ( kill -46 "$(pidof "${STATUSBAR:-dwmblocks}")" >/dev/null 2>&1 ) 2>/dev/null
- wait
- ( kill -46 "$(pidof "${STATUSBAR:-dwmblocks}")" >/dev/null 2>&1 ) 2>/dev/null
- notmuch new ;}
-
- notmuchauto() { \
- [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
- [ -f "$NOTMUCH_CONFIG" ] && return 0
- nmbasic="[database]
- path=$maildir
- [user]
- name=$realname
- primary_email=$fulladdr
- [new]
- tags=unread;inbox;
- ignore=.mbsyncstate;.uidvalidity
- [search]
- exclude_tags=deleted;spam;
- [maildir]
- synchronize_flags=true
- [crypto]
- gpg_path=$GPG"
- echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
-
- setact() { if [ -n "${action+x}" ] && [ "$action" != "$1" ]; then
- echo "Running $1 with $action..."
- echo "Incompatible options given. Only one action may be specified per run."
- return 1
- else
- action="$1"
- fi; }
-
- trap 'echo -e "\033[0m\n"; exit' INT ABRT
-
- while getopts "fplhodYD:y:i:I:s:S:u:a:n:x:m:" o; do case "${o}" in
- l) setact list || exit 1 ;;
- d) setact delete || exit 1 ;;
- D) setact delete || exit 1 ; fulladdr="$OPTARG" ;;
- y) setact sync || exit 1 ; fulladdr="$OPTARG" ;;
- Y) setact sync || exit 1 ;;
- a) setact add || exit 1 ; fulladdr="$OPTARG" ;;
- i) setact add || exit 1 ; imap="$OPTARG" ;;
- I) setact add || exit 1 ; iport="$OPTARG" ;;
- s) setact add || exit 1 ; smtp="$OPTARG" ;;
- S) setact add || exit 1 ; sport="$OPTARG" ;;
- u) setact add || exit 1 ; login="$OPTARG" ;;
- n) setact add || exit 1 ; realname="$OPTARG" ;;
- m) setact add || exit 1 ; maxmes="$OPTARG" ;;
- o) setact add || exit 1 ; online=True ;;
- f) setact add || exit 1 ; force=True ;;
- x) setact add || exit 1 ; password="$OPTARG" ;;
- p) echo "NOTE: Protonmail users must install and configure Protonmail Bridge first for the first sync to work."
- imap="127.0.0.1"
- iport="1143"
- smtp="127.0.0.1"
- sport="1025"
- ssltype="None"
- tlsline="tls_fingerprint $(msmtp --serverinfo --host=$smtp --port=$sport --tls --tls-certcheck=off | awk '/SHA256:/ {print $2}')"
- setact add || exit 1
- ;;
- *) cat << EOF
- mw: mutt-wizard, auto-configure email accounts for mutt
- including downloadable mail with \`isync\`.
-
- Main actions:
- -a your@email.com Add an email address
- -l List email addresses configured
- -d Remove an already added address
- -D your@email.com Force remove account without confirmation
- -y your@email.com Sync mail for account by name
- -Y Sync mail for all accounts
-
- Options allowed with -a:
- -u Account login name if not full address
- -n "Real name" to be on the email account
- -i IMAP server address
- -I IMAP server port
- -s SMTP server address
- -S SMTP server port
- -x Password for account (recommended to be in double quotes)
- -p Install for a Protonmail account.
- -o Configure address, but keep mail online.
- -f Assume typical English mailboxes without attempting log-on.
-
- NOTE: Once at least one account is added, you can run
- \`mbsync -a\` to begin downloading mail.
-
- To change an account's password, run \`pass edit ${pass_prefix}your@email.com\`.
- EOF
- exit 1
- ;;
- esac done
-
- ! command -v mbsync >/dev/null && [ -z "${force+x}" ] && printf "\`mbsync (isync package)\` must be installed to run mutt-wizard.\\n" && exit 1
-
- case "$action" in
- list) list ;;
- add) askinfo && getprofiles && writeinfo && getboxes && finalize || { delete ; exit 1 ;} ;;
- delete) delete $fulladdr ;;
- sync) syncwrapper $fulladdr ;;
- esac
|